import 'package:auto_injector/src/auto_injector_base.dart';
import 'package:test/test.dart';

void main() {
  test('AutoInjector: add', () async {
    final injector = AutoInjector();

    expect(injector.hasInjection<TestDatasource>(), false);

    injector.add(TestDatasource.new);

    expect(injector.hasInjection<TestDatasource>(), true);
  });

  test('AutoInjector: remove', () async {
    final injector = AutoInjector();
    injector.add<TestDatasource>(TestDatasource.new);
    expect(injector.hasInjection<TestDatasource>(), true);
    injector.remove<TestDatasource>();
    expect(injector.hasInjection<TestDatasource>(), false);
  });

  group('AutoInjector: get', () {
    test('zero input', () {
      final injector = AutoInjector();
      injector.add<TestDatasource>(TestDatasource.new);
      expect(injector.get<TestDatasource>(), isA<TestDatasource>());
    });
  });
}

class TestDatasource {}
